/*
  PPM Texture loader
  Created: 13/09/2002
  Author : Sylvain Lefebvre
*/
//---------------------------------------------------------------------------
#include "CTexturePPM.h"
#include "CLibTextureException.h"
//---------------------------------------------------------------------------
#include <iostream>
#include <string.h>
//---------------------------------------------------------------------------
using namespace std;
//---------------------------------------------------------------------------
CTexturePPM::CTexturePPM(const char *n) : CTexture()
{
  strcpy(m_szName,n);
  CTexturePPM::load();
}
//---------------------------------------------------------------------------
void CTexturePPM::load()
{
  ifstream      f;
  static char   line[512];
  int           type,size;
  
  m_iWidth=0;
  m_iHeight=0;
  m_Data=NULL;
  // ouverture m_szName
  f.open(m_szName,ifstream::in | ios::binary);
  if (!f)
    throw CLibTextureException("Unable to load ppm %s",m_szName);
  // lecture header
//  if (fget(f) != 'm' && fget(f) != 'p' && fget(f) != 'p')
//    throw CLibTextureException(true,"Unable to load ppm %s (bad signature)",m_szName);
  f.getline(line,512);
  if (line[0] != 'P')
    throw CLibTextureException("Unable to load ppm %s (bad id)",m_szName);
  type=(line[1]-'0');
    
  do
  {
    f.getline(line,512);
  }
  while (line[0] == '#');
  sscanf(line,"%d %d",&m_iWidth,&m_iHeight);
  f.getline(line,512);
  cerr << "Loading PPM image type " << type << ' ' << m_szName << ' ' << m_iWidth << 'x' << m_iHeight << endl;
  // size of data
  switch (type)
  {
  case 5:
    size=m_iWidth*m_iHeight;
    m_bAlpha=true;
    break;
  case 6:
    size=m_iWidth*m_iHeight*3;
    m_bAlpha=false;
    break;
  case 7:
    size=m_iWidth*m_iHeight*4;
    m_bAlpha=true;
    break;
  default:
    throw CLibTextureException("Unable to load tga %s (unknow type %d)",m_szName,type);
    break;
  }
  // reading data
  unsigned char *data=new unsigned char[size];
  if (m_bAlpha)
    m_Data=new unsigned char[m_iWidth*m_iHeight*4];
  else
    m_Data=new unsigned char[m_iWidth*m_iHeight*3];
  // lecture donnees
  f.read((char *)data,size);
  // fermeture m_szName
  f.close();
  // convert data
  for (int i=0;i<m_iWidth;i++)
  {
    for (int j=0;j<m_iHeight;j++)
    {
      switch (type)
      {
      case 5:
	m_Data[(i+j*m_iWidth)*4  ]=data[(i+j*m_iWidth)];
	m_Data[(i+j*m_iWidth)*4+1]=data[(i+j*m_iWidth)];
	m_Data[(i+j*m_iWidth)*4+2]=data[(i+j*m_iWidth)];
	m_Data[(i+j*m_iWidth)*4+3]=data[(i+j*m_iWidth)];
	break;
      case 6:
	m_Data[(i+j*m_iWidth)*3  ]=data[(i+j*m_iWidth)*3  ]; // FIXME pas efficace ! (mais souple)
	m_Data[(i+j*m_iWidth)*3+1]=data[(i+j*m_iWidth)*3+1];
	m_Data[(i+j*m_iWidth)*3+2]=data[(i+j*m_iWidth)*3+2];	
	break;
      case 7:
	m_Data[(i+j*m_iWidth)*4  ]=data[(i+j*m_iWidth)*4  ]; // FIXME pas efficace ! (mais souple)
	m_Data[(i+j*m_iWidth)*4+1]=data[(i+j*m_iWidth)*4+1];
	m_Data[(i+j*m_iWidth)*4+2]=data[(i+j*m_iWidth)*4+2];	
	m_Data[(i+j*m_iWidth)*4+3]=data[(i+j*m_iWidth)*4+3];	
	break;	
      }
    }
  }
  // ok
  delete[](data);
}
//---------------------------------------------------------------------------
