// ----------------------------------------------------------------------------
// CGPUmesh_GL_types.h
//
// The goal of this template class is to build a template mechanism
// above the OpenGL type definition.
// The run time overhead is null as everything is resolved at compile time.
//
// Exemple: GLTypes<float>::gl_define is equal to the GL_FLOAT define.
//
//                                                    (c) Sylvain Lefebvre 2003
// ----------------------------------------------------------------------------

#ifndef __GPUMESH_GL_TYPES__
#define __GPUMESH_GL_TYPES__

#include <GL/gl.h>

namespace GPUmesh {

template <typename T> struct GLTypes;

template <> struct GLTypes<float>
{
  enum    {gl_define = GL_FLOAT};
};

template <> struct GLTypes<double>
{
  enum    {gl_define = GL_DOUBLE};
};

template <> struct GLTypes<unsigned char>
{
  enum    {gl_define = GL_UNSIGNED_BYTE};
};

template <> struct GLTypes<unsigned int>
{
  enum    {gl_define = GL_UNSIGNED_INT};
};

template <> struct GLTypes<unsigned short>
{
  enum    {gl_define = GL_UNSIGNED_SHORT};
};

template <> struct GLTypes<MVF_null>
{
  enum    {gl_define = 0xFFFFFFFF};
};

} // namespace GPUmesh

#endif
